## flint-arb 2.11.1

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Arb.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Arb.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Arb"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Arb"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

## flint-arb 2.8.1

=== debian/changelog ===
flint-arb (2.8.1-3) unstable; urgency=medium

  * Add a patch from Logan Rosen to fix FTBFS with PIE. (Closes: #837454)
  * Push dh compat to 10.
  * Follow Multi-Arch hinter advices.

 -- Julien Puydt <julien.puydt@laposte.net>  Fri, 28 Oct 2016 13:42:44 +0200

flint-arb (2.8.1-2) unstable; urgency=medium

  [ Tobias Hansen ]
  * Team upload.
  * New patch flint_incldues.patch to fix flint includes.

  [ Julien Puydt ]
  * Push standards-version up to 3.9.8

 -- Tobias Hansen <thansen@debian.org>  Mon, 01 Aug 2016 17:57:17 +0100

flint-arb (2.8.1-1) unstable; urgency=medium

  * Initial release. (Closes: #797822)
  * Push standards-version up to 3.9.7
  * Fix Vcs-* fields

 -- Julien Puydt <julien.puydt@laposte.net>  Sun, 17 Apr 2016 21:48:37 +0200

=== debian/control ===
Source: flint-arb
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Julien Puydt <julien.puydt@laposte.net>
Homepage: https://github.com/fredrik-johansson/arb
Build-Depends: debhelper (>= 10), libflint-dev, libgmp-dev, libmpfr-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/flint-arb.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/flint-arb.git

Package: libflint-arb1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C library for arbitrary-precision ball arithmetic, shared library
 FLINT-ARB is a C library for high-performance arbitrary-precision
 floating-point ball (mid-rad interval) arithmetic. It supports complex
 numbers, polynomials, matrices, and evaluation of special functions, all
 with rigorous error bounding.
 .
 This package contains the shared library.

Package: libflint-arb-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libflint-arb1 (= ${binary:Version})
Description: C library for arbitrary-precision ball arithmetic, dev. files
 FLINT-ARB is a C library for high-performance arbitrary-precision
 floating-point ball (mid-rad interval) arithmetic. It supports complex
 numbers, polynomials, matrices, and evaluation of special functions, all
 with rigorous error bounding.
 .
 This package contains the development files.

Package: libflint-arb-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C library for arbitrary-precision ball arithmetic, documentation
 FLINT-ARB is a C library for high-performance arbitrary-precision
 floating-point ball (mid-rad interval) arithmetic. It supports complex
 numbers, polynomials, matrices, and evaluation of special functions, all
 with rigorous error bounding.
 .
 This package contains the documentation.

=== debian/watch ===
version=3
https://github.com/fredrik-johansson/arb/tags /fredrik-johansson/arb/archive/(\d[-\d.]*)\.tar\.gz

## flint-arb 2.11.1

=== debian/changelog ===
flint-arb (2.11.1-2build1) bionic; urgency=medium

  * No-change rebuild for mpfr soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 24 Jan 2018 21:19:50 +0000

flint-arb (2.11.1-2) unstable; urgency=medium

  * Team upload.
  * Bump flint Build-Depends version to pull in bugfixes there.

 -- Ximin Luo <infinity0@debian.org>  Thu, 09 Nov 2017 11:39:45 +0100

flint-arb (2.11.1-1) unstable; urgency=medium

  * New upstream release.
  * Mark libflint-arb1 as Multi-Arch: same.
  * Remove the fix flint includes patch (applied upstream).
  * Follow soname bump from 1 to 2.
  * Make the compilation of tests verbose (avoids build logs warnings).
  * Enable all hardening options.
  * Remove unused lintian override.
  * Install the lib into a multi-arch /usr/lib/ subdirectory using dh-exec.
  * Push standards-version to 4.1.1.
  * Bump d/watch to version 4.

 -- Julien Puydt <julien.puydt@laposte.net>  Mon, 06 Nov 2017 10:26:08 +0100

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,15 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Julien Puydt <julien.puydt@laposte.net>
 Homepage: https://github.com/fredrik-johansson/arb
-Build-Depends: debhelper (>= 10), libflint-dev, libgmp-dev, libmpfr-dev
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 10), dh-exec, libflint-dev (>= 2.5.2-17), libgmp-dev, libmpfr-dev
+Standards-Version: 4.1.1
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/flint-arb.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/flint-arb.git
 
-Package: libflint-arb1
+Package: libflint-arb2
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C library for arbitrary-precision ball arithmetic, shared library
  FLINT-ARB is a C library for high-performance arbitrary-precision
@@ -25,7 +26,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libflint-arb1 (= ${binary:Version})
+Depends: ${misc:Depends}, libflint-arb2 (= ${binary:Version})
 Description: C library for arbitrary-precision ball arithmetic, dev. files
  FLINT-ARB is a C library for high-performance arbitrary-precision
  floating-point ball (mid-rad interval) arithmetic. It supports complex

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

MAKE_OVERRIDE = AT= QUIET_CXX= QUIET_CC= QUIET_AR= ABI_FLAG='$(LDFLAGS) $(CPPFLAGS) $(CFLAGS)'

%:
	dh $@

# upstream Makefile has only CFLAGS, not CPPFLAGS and not even CXXFLAGS, so
# inject flags using configure. let's hope CFLAGS will always be good enough
# even for $(CXX)
override_dh_auto_configure:
	./configure --prefix=/usr --disable-static --with-flint=/usr CFLAGS='$(CPPFLAGS) $(CFLAGS)'
	sed -i Makefile -e "s/libarb/libflint-arb/g"
	sed -i Makefile -e "s/-larb/-lflint-arb/g"

override_dh_auto_build:
	dh_auto_build -- $(MAKE_OVERRIDE)

override_dh_auto_test:
	dh_auto_test -- $(MAKE_OVERRIDE)

## flint-arb 2.14.0

=== debian/changelog ===
flint-arb (1:2.14.0-4) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Tobias Hansen <thansen@debian.org>  Wed, 26 Sep 2018 20:25:16 +0200

flint-arb (1:2.14.0-3) experimental; urgency=medium

  * Add patch to fix testsuite on arm* architectures.
  * Bump std-ver to 4.2.1.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 18 Sep 2018 21:28:48 +0200

flint-arb (1:2.14.0-2) experimental; urgency=medium

  * Add patch to fix testuite on most architectures.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 15 Sep 2018 10:21:23 +0200

flint-arb (1:2.14.0-1) experimental; urgency=medium

  * New upstream release

 -- Julien Puydt <jpuydt@debian.org>  Tue, 24 Jul 2018 19:13:55 +0200

flint-arb (1:2.12.0-3) unstable; urgency=medium

  * Team upload to unstable.
  * Introducing epoch after accidental upload of flint-arb 2.13
    which is incompatible with sagemath 8.2.

 -- Tobias Hansen <thansen@debian.org>  Tue, 26 Jun 2018 17:07:30 +0200

flint-arb (2.13.0-1) unstable; urgency=medium

  * Team upload to unstable.
  * Remove fix-l_vec_hurwitz-test.patch.

  [ Julien Puydt ]
  * New upstream release.
  * Refresh packaging:
    - Bump std-ver to 4.1.4.
    - Use my debian.org mail address. 

 -- Tobias Hansen <thansen@debian.org>  Tue, 26 Jun 2018 11:04:28 +0200

flint-arb (2.12.0-2) experimental; urgency=medium

  * Team upload.
  * Add patch from arb 2.13 to fix test l_vec_hurwitz. (Closes: #896578)

 -- Tobias Hansen <thansen@debian.org>  Tue, 26 Jun 2018 00:46:08 +0200

flint-arb (2.12.0-1) experimental; urgency=medium

  * New upstream release.
  * Small packaging improvements:
    - Better description for -dev
    - Bump std-ver to 4.1.4.
    - Point Vcs-* to salsa.

 -- Julien Puydt <julien.puydt@laposte.net>  Wed, 18 Apr 2018 07:53:14 +0200

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+include /usr/share/dpkg/architecture.mk
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
@@ -14,6 +16,7 @@
 	./configure --prefix=/usr --disable-static --with-flint=/usr CFLAGS='$(CPPFLAGS) $(CFLAGS)'
 	sed -i Makefile -e "s/libarb/libflint-arb/g"
 	sed -i Makefile -e "s/-larb/-lflint-arb/g"
+	sed -i Makefile -e "s|LIBDIR=lib|LIBDIR=lib/$(DEB_HOST_MULTIARCH)|g"
 
 override_dh_auto_build:
 	dh_auto_build -- $(MAKE_OVERRIDE)

## flint-arb 2.16.0

=== debian/changelog ===
flint-arb (1:2.16.0-2) unstable; urgency=medium

  * Team upload to unstable.

 -- Tobias Hansen <thansen@debian.org>  Tue, 15 Jan 2019 13:41:05 +0100

flint-arb (1:2.16.0-1) experimental; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 12 Dec 2018 08:27:14 +0100

flint-arb (1:2.15.1-2) experimental; urgency=medium

  * Modify d/rules following H.Grohne to fix FTCBFS. (Closes: #914476)

 -- Julien Puydt <jpuydt@debian.org>  Fri, 23 Nov 2018 22:25:17 +0100

flint-arb (1:2.15.1-1) experimental; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 30 Oct 2018 09:49:25 +0100

flint-arb (1:2.15.0-1) experimental; urgency=medium

  * New upstream release.
  * Drop all upstreamed patches.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 04 Oct 2018 22:14:39 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: math
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Julien Puydt <julien.puydt@laposte.net>
+Uploaders: Julien Puydt <jpuydt@debian.org>
 Homepage: https://github.com/fredrik-johansson/arb
-Build-Depends: debhelper (>= 10), dh-exec, libflint-dev (>= 2.5.2-17), libgmp-dev, libmpfr-dev
-Standards-Version: 4.1.1
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/flint-arb.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/flint-arb.git
+Build-Depends: debhelper (>= 11), libflint-dev (>= 2.5.2-17), libgmp-dev, libmpfr-dev
+Standards-Version: 4.2.1
+Vcs-Browser: https://salsa.debian.org/science-team/flint-arb
+Vcs-Git: https://salsa.debian.org/science-team/flint-arb.git
 
 Package: libflint-arb2
 Section: libs
@@ -27,7 +27,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, libflint-arb2 (= ${binary:Version})
-Description: C library for arbitrary-precision ball arithmetic, dev. files
+Description: C library for arbitrary-precision ball arithmetic, development files
  FLINT-ARB is a C library for high-performance arbitrary-precision
  floating-point ball (mid-rad interval) arithmetic. It supports complex
  numbers, polynomials, matrices, and evaluation of special functions, all

## flint-arb 2.17.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(arb C)


if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type (Debug, Release)" FORCE)
endif ()

set (BUILD_SHARED_LIBS yes CACHE BOOL "Build shared library or not")
set (BUILD_TESTS no CACHE BOOL "Build tests or not")

if (NOT (CMAKE_BUILD_TYPE STREQUAL "Debug" OR
        CMAKE_BUILD_TYPE STREQUAL "Release"))
    message("${CMAKE_BUILD_TYPE}")
    message(FATAL_ERROR "CMAKE_BUILD_TYPE must be one of: Debug, Release (current value: '${CMAKE_BUILD_TYPE}')")
endif ()

if ("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
    set (PLATFORM "x64")
else ()
    set (PLATFORM "Win32")
endif()

if (BUILD_SHARED_LIBS)
    set (LIBRARY_TYPE dll)
else ()
    set (LIBRARY_TYPE lib)
endif()

set (MSVC_USE_MT yes CACHE BOOL "Use MT flags when compiling in MSVC")
set (MSVC_WARNING_LEVEL 1 CACHE STRING "MSVC warning level")

if (MSVC)
    if (MSVC_USE_MT)
        foreach(CompilerFlag CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE)
          string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
        endforeach()
    endif()
    foreach(CompilerFlag CMAKE_C_FLAGS)
      set(${CompilerFlag} "${${CompilerFlag}} /W${MSVC_WARNING_LEVEL} /DHAVE_TLS=1 /DFLINT_REENTRANT=0")
    endforeach()

    foreach(CompilerFlag CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE)
        if (BUILD_SHARED_LIBS)
            set(${CompilerFlag} "${${CompilerFlag}} /DMSC_USE_DLL")
        else ()
            set(${CompilerFlag} "${${CompilerFlag}} /DPTW32_STATIC_LIB")
        endif()
    endforeach()

    if ("${LIBRARY_TYPE}" STREQUAL "dll")
        set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS yes)
    endif()
endif()

set (DEPS mpir mpfr pthreads flint2)

set (mpir_lib gmp mpir)
set (mpfr_lib mpfr)
set (pthreads_lib pthreads pthread)
set (flint2_lib ${LIBRARY_TYPE}_flint flint)

set (mpir_header gmp.h)
set (mpfr_header mpfr.h)
set (pthreads_header pthread.h)
set (flint2_header flint/flint.h)

foreach (LIB ${DEPS})
    string (TOUPPER ${LIB} LIB_UPPER)
    find_library(${LIB_UPPER}_LIBRARY NAMES ${${LIB}_lib} HINTS ../${LIB}
                 PATH_SUFFIXES ${LIBRARY_TYPE}/${PLATFORM}/${CMAKE_BUILD_TYPE} NO_DEFAULT_PATH)
    if (NOT ${LIB_UPPER}_LIBRARY)
        message(FATAL_ERROR "${LIB} library not found.")
    endif()
    add_library(${LIB} UNKNOWN IMPORTED)
    set_property(TARGET ${LIB} PROPERTY IMPORTED_LOCATION ${${LIB_UPPER}_LIBRARY})
    message("${LIB} found in ${${LIB_UPPER}_LIBRARY}")

endforeach ()

foreach (LIB ${DEPS})
    string(TOUPPER ${LIB} HEADER_PKG)
    set (HEADER ${${LIB}_header})
    find_path(${HEADER_PKG}_INCLUDE_DIR NAMES ${HEADER} HINTS ../${LIB}
             PATH_SUFFIXES ${LIBRARY_TYPE}/${PLATFORM}/${CMAKE_BUILD_TYPE})
    if (NOT ${HEADER_PKG}_INCLUDE_DIR)
        message(FATAL_ERROR "${HEADER} header not found.")
    endif()
    message("${HEADER} found in ${${HEADER_PKG}_INCLUDE_DIR}")
    set (DEP_INCLUDE_DIRS ${DEP_INCLUDE_DIRS} ${${HEADER_PKG}_INCLUDE_DIR})
endforeach ()

file(GLOB TEMP "*.h")

foreach (TEMP_H ${TEMP})
    get_filename_component(FOLDER ${TEMP_H} NAME_WE)
    set(FOLDERS ${FOLDERS} ${FOLDER})
endforeach()

foreach (FOLDER ${FOLDERS})
    file(GLOB TEMP "${FOLDER}/*.c")
    set(SRC ${SRC} ${TEMP})
endforeach ()

include_directories(BEFORE ${arb_SOURCE_DIR})
include_directories(BEFORE ${DEP_INCLUDE_DIRS})

add_library(arb ${SRC})
target_link_libraries(arb ${DEPS})
target_compile_definitions(arb PRIVATE "ARB_BUILD_DLL")

if(NOT MSVC)
    target_link_libraries(arb m)
endif()

install(TARGETS arb
            RUNTIME DESTINATION bin
            ARCHIVE DESTINATION lib
            LIBRARY DESTINATION lib
        )

foreach (FOLDER ${FOLDERS})
    set(HEADERS ${HEADERS} ${FOLDER}.h)
endforeach ()

install(FILES ${HEADERS} DESTINATION include)

if (BUILD_TESTS)
    enable_testing()
    foreach (FOLDER ${FOLDERS})
        file(GLOB TEMP "${FOLDER}/test/*.c")
        foreach (TEST_SOURCE ${TEMP})
            get_filename_component(TEST_NAME ${TEST_SOURCE} NAME_WE)
            add_executable(${FOLDER}-${TEST_NAME} ${TEST_SOURCE})
            target_link_libraries(${FOLDER}-${TEST_NAME} arb)
            add_test(${FOLDER}-${TEST_NAME} ${FOLDER}-${TEST_NAME})
        endforeach ()
    endforeach ()
endif ()

=== debian/changelog ===
flint-arb (1:2.17.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop d/compat and swith to debhelper-compat 12.
  * Bump std-vers to 4.4.1.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 19 Oct 2019 22:07:04 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Homepage: https://github.com/fredrik-johansson/arb
-Build-Depends: debhelper (>= 11), libflint-dev (>= 2.5.2-17), libgmp-dev, libmpfr-dev
-Standards-Version: 4.2.1
+Build-Depends: debhelper-compat (= 12), libflint-dev (>= 2.5.2-17), libgmp-dev, libmpfr-dev
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/science-team/flint-arb
 Vcs-Git: https://salsa.debian.org/science-team/flint-arb.git

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,11 @@
 
 MAKE_OVERRIDE = AT= QUIET_CXX= QUIET_CC= QUIET_AR= ABI_FLAG='$(LDFLAGS) $(CPPFLAGS) $(CFLAGS)'
 
+ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+include /usr/share/dpkg/buildtools.mk
+CONFIGURE_FLAGS = --build=$(DEB_HOST_GNU_CPU)-$(DEB_HOST_ARCH_OS) CC=$(CC) CXX=$(CXX) AR=$(AR)
+endif
+
 %:
 	dh $@
 
@@ -13,7 +18,7 @@
 # inject flags using configure. let's hope CFLAGS will always be good enough
 # even for $(CXX)
 override_dh_auto_configure:
-	./configure --prefix=/usr --disable-static --with-flint=/usr CFLAGS='$(CPPFLAGS) $(CFLAGS)'
+	./configure --prefix=/usr --disable-static --with-flint=/usr CFLAGS='$(CPPFLAGS) $(CFLAGS)' $(CONFIGURE_FLAGS)
 	sed -i Makefile -e "s/libarb/libflint-arb/g"
 	sed -i Makefile -e "s/-larb/-lflint-arb/g"
 	sed -i Makefile -e "s|LIBDIR=lib|LIBDIR=lib/$(DEB_HOST_MULTIARCH)|g"

## flint-arb 2.18.1

=== debian/changelog ===
flint-arb (1:2.18.1-2) unstable; urgency=medium

  * Fix duplicate entries in d/copyright.
  * Declare d/rules doesn't require root.
  * Bump dh compat to 13.
  * Ship the api documentation in html (Closes: 968872)

 -- Julien Puydt <jpuydt@debian.org>  Tue, 25 Aug 2020 18:42:48 +0200

flint-arb (1:2.18.1-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 01 Jul 2020 11:17:26 +0200

flint-arb (1:2.18.0-1) unstable; urgency=medium

  * New upstream release.
  * Change the debian-science-maintainers' address.
  * Bump std-vers to 4.5.0.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 17 Jun 2020 10:37:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,18 @@
 Source: flint-arb
 Section: math
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Homepage: https://github.com/fredrik-johansson/arb
-Build-Depends: debhelper-compat (= 12), libflint-dev (>= 2.5.2-17), libgmp-dev, libmpfr-dev
-Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 13),
+               libflint-dev (>= 2.5.2-17),
+               libgmp-dev,
+               libjs-jquery,
+               libjs-underscore,
+               libmpfr-dev,
+               sphinx
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/science-team/flint-arb
 Vcs-Git: https://salsa.debian.org/science-team/flint-arb.git
 
@@ -13,7 +20,7 @@
 Section: libs
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: C library for arbitrary-precision ball arithmetic, shared library
  FLINT-ARB is a C library for high-performance arbitrary-precision
  floating-point ball (mid-rad interval) arithmetic. It supports complex
@@ -26,7 +33,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libflint-arb2 (= ${binary:Version})
+Depends: libflint-arb2 (= ${binary:Version}), ${misc:Depends}
 Description: C library for arbitrary-precision ball arithmetic, development files
  FLINT-ARB is a C library for high-performance arbitrary-precision
  floating-point ball (mid-rad interval) arithmetic. It supports complex

## flint-arb 2.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,23 @@
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.1)
 
 project(arb C)
 
+file(READ "${CMAKE_CURRENT_SOURCE_DIR}/configure" CONFIGURE_CONTENTS)
+string(REGEX MATCH "ARB_MAJOR=([0-9]*)" _ ${CONFIGURE_CONTENTS})
+set(ARB_MAJOR ${CMAKE_MATCH_1})
+string(REGEX MATCH "ARB_MINOR=([0-9]*)" _ ${CONFIGURE_CONTENTS})
+set(ARB_MINOR ${CMAKE_MATCH_1})
+string(REGEX MATCH "ARB_PATCH=([0-9]*)" _ ${CONFIGURE_CONTENTS})
+set(ARB_PATCH ${CMAKE_MATCH_1})
+
+set(ARB_VERSION "${ARB_MAJOR}.${ARB_MINOR}.${ARB_PATCH}")
 
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type (Debug, Release)" FORCE)
 endif ()
 
 set (BUILD_SHARED_LIBS yes CACHE BOOL "Build shared library or not")
-set (BUILD_TESTS no CACHE BOOL "Build tests or not")
+set (BUILD_TESTING no CACHE BOOL "Build tests or not")
 
 if (NOT (CMAKE_BUILD_TYPE STREQUAL "Debug" OR
         CMAKE_BUILD_TYPE STREQUAL "Release"))
@@ -38,7 +47,7 @@
         endforeach()
     endif()
     foreach(CompilerFlag CMAKE_C_FLAGS)
-      set(${CompilerFlag} "${${CompilerFlag}} /W${MSVC_WARNING_LEVEL} /DHAVE_TLS=1 /DFLINT_REENTRANT=0")
+      set(${CompilerFlag} "${${CompilerFlag}} /W${MSVC_WARNING_LEVEL}")
     endforeach()
 
     foreach(CompilerFlag CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE)
@@ -54,7 +63,7 @@
     endif()
 endif()
 
-set (DEPS mpir mpfr pthreads flint2)
+set (DEPS flint2 mpfr mpir)
 
 set (mpir_lib gmp mpir)
 set (mpfr_lib mpfr)
@@ -66,17 +75,25 @@
 set (pthreads_header pthread.h)
 set (flint2_header flint/flint.h)
 
+if(MSVC)
+    set(DEPS ${DEPS} pthreads)
+else()
+    option(CMAKE_THREAD_PREFER_PTHREAD "Prefer pthreads" yes)
+    option(THREADS_PREFER_PTHREAD_FLAG "Prefer -pthread flag" yes)
+    find_package(Threads REQUIRED)
+    set(PTHREADS_LIBRARIES Threads::Threads)
+endif()
+
 foreach (LIB ${DEPS})
     string (TOUPPER ${LIB} LIB_UPPER)
     find_library(${LIB_UPPER}_LIBRARY NAMES ${${LIB}_lib} HINTS ../${LIB}
-                 PATH_SUFFIXES ${LIBRARY_TYPE}/${PLATFORM}/${CMAKE_BUILD_TYPE} NO_DEFAULT_PATH)
+                 PATH_SUFFIXES ${LIBRARY_TYPE}/${PLATFORM}/${CMAKE_BUILD_TYPE})
     if (NOT ${LIB_UPPER}_LIBRARY)
         message(FATAL_ERROR "${LIB} library not found.")
     endif()
     add_library(${LIB} UNKNOWN IMPORTED)
     set_property(TARGET ${LIB} PROPERTY IMPORTED_LOCATION ${${LIB_UPPER}_LIBRARY})
     message("${LIB} found in ${${LIB_UPPER}_LIBRARY}")
-
 endforeach ()
 
 foreach (LIB ${DEPS})
@@ -107,8 +124,13 @@
 include_directories(BEFORE ${DEP_INCLUDE_DIRS})
 
 add_library(arb ${SRC})
-target_link_libraries(arb ${DEPS})
+target_link_libraries(arb ${DEPS} ${PTHREADS_LIBRARIES})
 target_compile_definitions(arb PRIVATE "ARB_BUILD_DLL")
+
+set_target_properties(arb PROPERTIES VERSION ${ARB_VERSION} SOVERSION ${ARB_MAJOR})
+if(WIN32)
+    set_target_properties(arb PROPERTIES RUNTIME_OUTPUT_NAME "arb-${ARB_MAJOR}")
+endif()
 
 if(NOT MSVC)
     target_link_libraries(arb m)
@@ -126,14 +148,14 @@
 
 install(FILES ${HEADERS} DESTINATION include)
 
-if (BUILD_TESTS)
+if (BUILD_TESTING)
     enable_testing()
     foreach (FOLDER ${FOLDERS})
         file(GLOB TEMP "${FOLDER}/test/*.c")
         foreach (TEST_SOURCE ${TEMP})
             get_filename_component(TEST_NAME ${TEST_SOURCE} NAME_WE)
             add_executable(${FOLDER}-${TEST_NAME} ${TEST_SOURCE})
-            target_link_libraries(${FOLDER}-${TEST_NAME} arb)
+            target_link_libraries(${FOLDER}-${TEST_NAME} arb ${PTHREADS_LIBRARIES})
             add_test(${FOLDER}-${TEST_NAME} ${FOLDER}-${TEST_NAME})
         endforeach ()
     endforeach ()

=== debian/changelog ===
flint-arb (1:2.19.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump std-vers to 4.5.1.
  * Make -dev depend on libflint-dev. (Closes: #974598)

 -- Julien Puydt <jpuydt@debian.org>  Tue, 08 Dec 2020 09:04:36 +0100

flint-arb (1:2.18.1-3) unstable; urgency=medium

  * Change license to LGPL-2.1+ following upstream,
   and update d/copyright.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 25 Oct 2020 10:31:16 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                libjs-underscore,
                libmpfr-dev,
                sphinx
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/science-team/flint-arb
 Vcs-Git: https://salsa.debian.org/science-team/flint-arb.git
@@ -33,7 +33,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libflint-arb2 (= ${binary:Version}), ${misc:Depends}
+Depends: libflint-arb2 (= ${binary:Version}), libflint-dev, ${misc:Depends}
 Description: C library for arbitrary-precision ball arithmetic, development files
  FLINT-ARB is a C library for high-performance arbitrary-precision
  floating-point ball (mid-rad interval) arithmetic. It supports complex

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
 include /usr/share/dpkg/buildtools.mk
-CONFIGURE_FLAGS = --build=$(DEB_HOST_GNU_CPU)-$(DEB_HOST_ARCH_OS) CC=$(CC) CXX=$(CXX) AR=$(AR)
+CONFIGURE_FLAGS = --=$(DEB_HOST_GNU_CPU)-$(DEB_HOST_ARCH_OS) CC=$(CC) CXX=$(CXX) AR=$(AR)
 endif
 
 %:
@@ -25,6 +25,10 @@
 
 override_dh_auto_build:
 	dh_auto_build -- $(MAKE_OVERRIDE)
+	make -C doc/ html
+	find doc/ -type f -name "*.html" | \
+		xargs sed -i -e "s|https://cdnjs.cloudflare.com/ajax/libs/mathjax/.*/latest.js|file:///usr/share/javascript/mathjax/MathJax.js|g"
+	rm doc/build/html/_static/doctools.js doc/build/html/_static/jquery.js doc/build/html/_static/language_data.js doc/build/html/_static/searchtools.js doc/build/html/_static/underscore.js
 
 override_dh_auto_test:
 	dh_auto_test -- $(MAKE_OVERRIDE)

=== debian/watch ===
version=4
https://github.com/fredrik-johansson/arb/tags /fredrik-johansson/arb/archive/(\d[-\d.]*)\.tar\.gz

## flint-arb 2.22.1

=== debian/changelog ===
flint-arb (1:2.22.1-1) unstable; urgency=medium

  * New upstream release (dropping upstreamed patch).

 -- Julien Puydt <jpuydt@debian.org>  Mon, 31 Jan 2022 09:20:50 +0100

flint-arb (1:2.22.0-2) unstable; urgency=medium

  * Add patch to fix FTBFS on many architectures.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 21 Jan 2022 09:43:58 +0100

flint-arb (1:2.22.0-1) unstable; urgency=medium

  * New upstream release.
  * Fix upstream metadata file

 -- Julien Puydt <jpuydt@debian.org>  Mon, 17 Jan 2022 16:11:04 +0100

flint-arb (1:2.21.1-2) unstable; urgency=medium

  * Move the package to the Math Team.
  * Make -dev suggest -doc (thanks John Scott).
  * Add upstream/metadata.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 11 Dec 2021 18:59:39 +0100

flint-arb (1:2.21.1-1) unstable; urgency=medium

  * New upstream release (closes: #995185).
  * Refresh patch.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 21 Oct 2021 09:16:44 +0200

flint-arb (1:2.21.0-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 27 Sep 2021 08:25:49 +0200

flint-arb (1:2.20.0-1) unstable; urgency=medium

  * Fix d/watch.
  * Bump std-vers to 4.6.0.
  * New upstream release.
  * Rework doc installation (Closes: #990664).

 -- Julien Puydt <jpuydt@debian.org>  Thu, 26 Aug 2021 13:10:05 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: flint-arb
 Section: math
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Homepage: https://github.com/fredrik-johansson/arb
 Build-Depends: debhelper-compat (= 13),
@@ -11,10 +11,10 @@
                libjs-underscore,
                libmpfr-dev,
                sphinx
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
-Vcs-Browser: https://salsa.debian.org/science-team/flint-arb
-Vcs-Git: https://salsa.debian.org/science-team/flint-arb.git
+Vcs-Browser: https://salsa.debian.org/math-team/flint-arb
+Vcs-Git: https://salsa.debian.org/math-team/flint-arb.git
 
 Package: libflint-arb2
 Section: libs
@@ -34,6 +34,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: libflint-arb2 (= ${binary:Version}), libflint-dev, ${misc:Depends}
+Suggests: libflint-arb-doc
 Description: C library for arbitrary-precision ball arithmetic, development files
  FLINT-ARB is a C library for high-performance arbitrary-precision
  floating-point ball (mid-rad interval) arithmetic. It supports complex
@@ -46,7 +47,7 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Description: C library for arbitrary-precision ball arithmetic, documentation
  FLINT-ARB is a C library for high-performance arbitrary-precision
  floating-point ball (mid-rad interval) arithmetic. It supports complex

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 endif
 
 %:
-	dh $@
+	dh $@ --with sphinxdoc
 
 # upstream Makefile has only CFLAGS, not CPPFLAGS and not even CXXFLAGS, so
 # inject flags using configure. let's hope CFLAGS will always be good enough
@@ -28,7 +28,6 @@
 	make -C doc/ html
 	find doc/ -type f -name "*.html" | \
 		xargs sed -i -e "s|https://cdnjs.cloudflare.com/ajax/libs/mathjax/.*/latest.js|file:///usr/share/javascript/mathjax/MathJax.js|g"
-	rm doc/build/html/_static/doctools.js doc/build/html/_static/jquery.js doc/build/html/_static/language_data.js doc/build/html/_static/searchtools.js doc/build/html/_static/underscore.js
 
 override_dh_auto_test:
 	dh_auto_test -- $(MAKE_OVERRIDE)

## flint-arb 2.23.0

=== debian/changelog ===
flint-arb (1:2.23.0-1) unstable; urgency=medium

  * New upstream release.
  * Adapt patches to new release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 09 Jul 2022 15:17:03 +0200

flint-arb (1:2.22.1-3) unstable; urgency=medium

  * Add patch to be compatible with the future flint 2.9.0.
  * Bump standards-version to 4.6.1.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 19 May 2022 11:56:44 +0200

flint-arb (1:2.22.1-2) unstable; urgency=medium

  * Add patch fixing a mips64el issue (Closes: #1007980).

 -- Julien Puydt <jpuydt@debian.org>  Fri, 01 Apr 2022 20:15:17 +0200

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Homepage: https://github.com/fredrik-johansson/arb
 Build-Depends: debhelper-compat (= 13),
-               libflint-dev (>= 2.5.2-17),
+               libflint-dev (>= 2.9.0),
                libgmp-dev,
                libjs-jquery,
                libjs-underscore,
                libmpfr-dev,
                sphinx
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/math-team/flint-arb
 Vcs-Git: https://salsa.debian.org/math-team/flint-arb.git

=== debian/watch ===
version=4
https://github.com/fredrik-johansson/arb/tags .*/(\d[-\d.]*)\.tar\.gz
